<script setup>
import {ref} from 'vue'
import {useGroupStore} from "@/stores/group"
import {useRoomStore} from "@/stores/room";
import {useEnumStore} from "@/stores/enumStore";

const groupStore = useGroupStore()
const groupName = ref("")
const specializations = ref("")
const groupNumber = ref("")
const groupStart = ref("")
const groupEnd = ref("")
const roomId = ref()
const roomStore = useRoomStore()
const enumStore = useEnumStore()

const apiError = ref("")

async function createGroup() {

  apiError.value = ""

  try {
    const response = await groupStore.createGroup({
      specializations: specializations.value,
      groupNumber: groupNumber.value,
      startDate: groupStart.value,
      endDate: groupEnd.value,
      roomId: roomId.value
    })
    roomStore.rooms.find(room => response.roomId === room.roomId).groupId = response.groupId
  } catch (err) {
    if (err.isAxiosError && err.status === 401) {
      apiError.value = "You must be logged in"
    } else {
      apiError.value = "Unknown error"
    }
  }

  specializations.value = ""
  groupNumber.value = ""
  groupStart.value = ""
  groupEnd.value = ""
  roomId.value = null
}


</script>

<template>
  <div class="bg-black text-white rounded-2 p-3">
    <form @submit.prevent="createGroup">
      <div class="mb-3 row">
        <label class="col-12 col-md-6">
          <span class="form-label">Name</span>
          <select class="form-select" name="name" v-model="specializations" required>
            <option v-for="spec in enumStore.specializations">{{ spec }}</option>
          </select>
        </label>
        <label class="col-12 col-md-6">
          <span class="form-label">Number</span>
          <input type="text" name="number" v-model="groupNumber" class="form-control" required>
        </label>
        <label class="col-12 col-md-6">
          <span class="form-label">Start Date</span>
          <input type="date" name="start" v-model="groupStart" class="form-control" required>
        </label>
        <label class="col-12 col-md-6">
          <span class="form-label">End Date</span>
          <input type="date" name="end" v-model="groupEnd" class="form-control" required>
        </label>
        <label class="col-12 col-md-6 mt-1">
          <span class="form-label">Room</span>
          <select class="form-select" name="name" v-model="roomId">
            <option v-for="room in roomStore.rooms" :value="room.roomId">{{ room.roomNumber }} {{ room.vip }}</option>
          </select>
        </label>
      </div>
      <button type="submit" class="btn btn-warning">Add Group</button>
    </form>
  </div>
</template>

<style scoped>
.bg-black {
  width: 1000px;
}
</style>